'''
qdos.py
Uses the QDOS SPARQL endpoint to figure out the social data

Author: oshani@mit.edu
Date: Aug 26th, 2008
'''

#!/usr/local/bin/python

import httplib
import urllib
import re

#Do not touch this!
key = "6eabf5346c342d3e80e80efe1ac46392467e3891"

def find_foaf(flickr_user):

    conn = httplib.HTTPConnection("qdos.com")

    query = '''PREFIX q: <http://qdos.com/schema#> 
               PREFIX foaf: <http://xmlns.com/foaf/0.1/> 
               SELECT ?foaf  
               WHERE { 
                  ?x q:foaf ?foaf . 
                  ?x q:flickr <'''+ flickr_user+ '''> . 
                  ?x foaf:name ?name . }'''
    
    params = urllib.urlencode({'query': query, 'key': key})
    request_endpoint = "/sparql?"
    url_str = request_endpoint + params
    conn.request("GET", url_str)
    res = conn.getresponse()
    data = res.read()
    pattern = re.compile('http[s]*://[a-zA-Z0-9./@#~]+') #very trivial url pattern - watch out, it might break!
    return pattern.findall(data)

def find_name(flickr_user):

    conn = httplib.HTTPConnection("qdos.com")

    query = '''PREFIX q: <http://qdos.com/schema#> 
               PREFIX foaf: <http://xmlns.com/foaf/0.1/> 
               SELECT ?name  
               WHERE { 
                  ?x q:foaf ?foaf . 
                  ?x q:flickr <'''+ flickr_user+ '''> . 
                  ?x foaf:name ?name . }'''
    
    params = urllib.urlencode({'query': query, 'key': key})
    request_endpoint = "/sparql?"
    url_str = request_endpoint + params
    conn.request("GET", url_str)
    res = conn.getresponse()
    data = res.read()
    pattern = re.compile('[^?name\s"][A-Za-z\s]+') #very trivial url pattern - watch out, it might break!
    return pattern.findall(data)


if __name__ == "__main__":
    foaf = find_foaf("http://www.flickr.com/photos/83649821@N00")
    name = find_name("http://www.flickr.com/photos/83649821@N00")
    print "\nFOAF\n", foaf[0]
    print "\nName\n", name[0]

    
